import { world, BlockPermutation } from "@minecraft/server";

const pumpkinVariants = [
    "minecraft:carved_pumpkin",
    "eu:carved_pumpkin_1",
    "eu:carved_pumpkin_2",
    "eu:carved_pumpkin_3",
    "eu:carved_pumpkin_4",
    "eu:carved_pumpkin_5",
    "eu:carved_pumpkin_6",
    "eu:carved_pumpkin_7",
    "eu:carved_pumpkin_8",
    "eu:carved_pumpkin_9",
    "eu:carved_pumpkin_10",
    "eu:carved_pumpkin_11",
    "eu:carved_pumpkin_12",
    "eu:carved_pumpkin_13",
    "eu:carved_pumpkin_14",
    "eu:carved_pumpkin_15",
    "eu:carved_pumpkin_16",
    "eu:carved_pumpkin_17"

];
function updateItemDurability(source, item, durabilityModifier = 1) {
    const equippable = source.getComponent("equippable");
    const durability = item.getComponent("durability");

    durability.damage += durabilityModifier;

    const maxDurability = durability.maxDurability
    const currentDamage = durability.damage
    if (currentDamage >= maxDurability) {


        source.playSound('random.break', { pitch: 1, location: source.location, volume: 1 })
        equippable.setEquipment("Mainhand", undefined);
    }
    else if (currentDamage < maxDurability) {

        equippable.setEquipment("Mainhand", item);
    }
}


world.beforeEvents.playerInteractWithBlock.subscribe(async event => {

    const { block, itemStack, isFirstEvent, blockFace, player } = event;

    if (itemStack?.typeId == 'minecraft:shears' && pumpkinVariants.includes(block.typeId) && isFirstEvent) {
        await null;
        const randomPumpkin = pumpkinVariants[Math.floor(Math.random() * pumpkinVariants.length)];

        block.setPermutation(BlockPermutation.resolve(randomPumpkin).withState('minecraft:cardinal_direction', blockFace.toLowerCase()));
        player.playSound('pumpkin.carve')
        updateItemDurability(player, itemStack)
    }
});

/* Debug
world.beforeEvents.playerInteractWithBlock.subscribe(async event => {

    const { block, itemStack, isFirstEvent, player } = event;

    if (itemStack?.typeId == 'minecraft:stick' && isFirstEvent) {
        await null;
        let states = block.permutation.getAllStates()
        world.sendMessage(JSON.stringify(states))
        world.sendMessage(event.blockFace)
        let state = block.permutation.getState()

        let permutation = block.permutation.withState('minecraft:cardinal_direction', event.blockFace.toLowerCase())
        block.setPermutation(permutation);
    }
});
 */
